#
# Conditional build:
%bcond_without	lcd		# without LCD subpixel color filtering (Microsoft patents in USA)
%bcond_without	harfbuzz	# harfbuzz based autohinting
#
%define		realname   freetype
Summary:	TrueType font rasterizer - MinGW32 cross version
Summary(pl.UTF-8):	Rasteryzer fontów TrueType - wersja skrośna dla MinGW32
Name:		crossmingw32-%{realname}
Version:	2.11.1
Release:	1
License:	GPL v2 or FTL
Group:		Development/Libraries
Source0:	https://download.savannah.gnu.org/releases/freetype/%{realname}-%{version}.tar.xz
# Source0-md5:	24e79233d607ded439ef36ff1f3ab68f
URL:		https://freetype.org/
BuildRequires:	crossmingw32-bzip2
BuildRequires:	crossmingw32-gcc
%{?with_harfbuzz:BuildRequires:	crossmingw32-harfbuzz >= 2.0.0}
BuildRequires:	crossmingw32-libpng
BuildRequires:	crossmingw32-zlib >= 1.2.3-2
BuildRequires:	pkgconfig >= 1:0.24
BuildRequires:	python
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
Requires:	crossmingw32-bzip2
%{?with_harfbuzz:Requires:	crossmingw32-harfbuzz >= 2.0.0}
Requires:	crossmingw32-libpng
Requires:	crossmingw32-zlib >= 1.2.3-2
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		specflags_ia32	-fomit-frame-pointer
# see <freetype/internal/ftserv.h>, the real horror
%define		specflags	-fno-strict-aliasing

%define		no_install_post_strip	1
%define		_enable_debug_packages	0

%define		target			i386-mingw32
%define		target_platform 	i386-pc-mingw32

%define		_sysprefix		/usr
%define		_prefix			%{_sysprefix}/%{target}
%define		_libdir			%{_prefix}/lib
%define		_pkgconfigdir		%{_prefix}/lib/pkgconfig
%define		_dlldir			/usr/share/wine/windows/system
%define		__cc			%{target}-gcc
%define		__cxx			%{target}-g++
%define		__pkgconfig_provides	%{nil}
%define		__pkgconfig_requires	%{nil}

%ifnarch %{ix86}
# arch-specific flags (like alpha's -mieee) are not valid for i386 gcc
%define		optflags	-O2
%endif
# -z options are invalid for mingw linker, most of -f options are Linux-specific
%define		filterout_ld	-Wl,-z,.*
%define		filterout_c	-f[-a-z0-9=]*

%description
The FreeType engine is a free and portable TrueType font rendering
engine. It has been developed to provide TrueType support to a great
variety of platforms and environments.

Note that FreeType is a *library*. It is not a font server for your
favorite platform, even though it was designed to be used in many of
them. Note also that it is *not* a complete text-rendering library.
Its purpose is simply to open and manage font files, as well as load,
hint and render individual glyphs efficiently. You can also see it as
a "TrueType driver" for a higher-level library, though rendering text
with it is extremely easy, as demo-ed by the test programs.

This package contains the cross version for Win32.

%description -l pl.UTF-8
FreeType jest biblioteką służącą do rasteryzacji fontów
TrueType. Jest to jedynie biblioteka, a nie serwer fontów, chociaż
została ona zaprojektowana do używania także w takich serwerach.
Nie jest to też kompletna biblioteka do rasteryzacji tekstu. Jej
celem jest tylko odczytywanie i zarządzanie plikami z fontami oraz
wczytywanie i wykonywanie hintingu i rasteryzacji poszczególnych
glifów. Może być także uważana za "sterownik TrueType" dla
bibliotek wyższego poziomu, jednak użycie samej biblioteki FreeType
do rasteryzacji jest bardzo proste, co można zobaczyć w programach
demonstracyjnych.

Ten pakiet zawiera wersję skrośną dla Win32.

%package static
Summary:	Static freetype library (cross MinGW32 version)
Summary(pl.UTF-8):	Statyczna biblioteka freetype (wersja skrośna MinGW32)
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description static
Static freetype library (cross MinGW32 version).

%description static -l pl.UTF-8
Statyczna biblioteka freetype (wersja skrośna MinGW32).

%package dll
Summary:	DLL freetype library for Windows
Summary(pl.UTF-8):	Biblioteka DLL freetype dla Windows
Group:		Applications/Emulators
Requires:	crossmingw32-bzip2-dll
%{?with_harfbuzz:Requires:	crossmingw32-harfbuzz-dll >= 2.0.0}
Requires:	crossmingw32-libpng-dll
Requires:	crossmingw32-zlib-dll
Requires:	wine

%description dll
DLL freetype library for Windows.

%description dll -l pl.UTF-8
Biblioteka DLL freetype dla Windows.

%prep
%setup -q -n %{realname}-%{version}

%build
export PKG_CONFIG_LIBDIR=%{_pkgconfigdir}
CFLAGS="%{rpmcflags} \
%{?with_lcd:-DFT_CONFIG_OPTION_SUBPIXEL_RENDERING} \
-DTT_CONFIG_OPTION_SUBPIXEL_HINTING \
" \
%configure \
	LIBPNG_CFLAGS="$(pkg-config --cflags libpng)" \
	LIBPNG_LDFLAGS="$(pkg-config --libs libpng)" \
	--target=%{target} \
	--build=i686-pc-linux-gnu \
	--host=%{target} \
	--enable-shared \
	%{!?with_harfbuzz:--without-harfbuzz}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_dlldir}
%{__mv} -f $RPM_BUILD_ROOT%{_prefix}/bin/*.dll $RPM_BUILD_ROOT%{_dlldir}

%if 0%{!?debug:1}
%{target}-strip --strip-unneeded -R.comment -R.note $RPM_BUILD_ROOT%{_dlldir}/*.dll
%{target}-strip -g -R.comment -R.note $RPM_BUILD_ROOT%{_libdir}/*.a
%endif

%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/aclocal

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE.TXT docs/{CHANGES,FTL.TXT,TODO,formats.txt,raster.txt}
%{_libdir}/libfreetype.dll.a
%{_libdir}/libfreetype.la
%{_includedir}/freetype2
%{_pkgconfigdir}/freetype2.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libfreetype.a

%files dll
%defattr(644,root,root,755)
%{_dlldir}/libfreetype-*.dll
%changelog
* Sun Dec 05 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/crossmingw32-freetype.git;a=log;h=master

* Sun Dec 05 2021 Jakub Bogusz <qboosh@pld-linux.org> c5c5c96
- updated to 2.11.1

* Mon Jul 26 2021 Jakub Bogusz <qboosh@pld-linux.org> faca7b5
- disable debug packages

* Mon Jul 26 2021 Jakub Bogusz <qboosh@pld-linux.org> 0373863
- updated to 2.11.0

* Tue Oct 20 2020 Jakub Bogusz <qboosh@pld-linux.org> c6e3d73
- updated to 2.10.4

* Sun Oct 11 2020 Jakub Bogusz <qboosh@pld-linux.org> 0fa4839
- updated to 2.10.3

* Sat May 09 2020 Jakub Bogusz <qboosh@pld-linux.org> 8a56015
- updated to 2.10.2

* Thu Sep 05 2019 Jakub Bogusz <qboosh@pld-linux.org> b2f7299
- release 2

* Thu Sep 05 2019 Jakub Bogusz <qboosh@pld-linux.org> bcef083
- bootstrap release 1.1

* Tue Jul 02 2019 Jakub Bogusz <qboosh@pld-linux.org> 41b0526
- updated to 2.10.1

* Mon Mar 25 2019 Jakub Bogusz <qboosh@pld-linux.org> ad20f62
- updated to 2.10.0

* Sat Dec 22 2018 Jakub Bogusz <qboosh@pld-linux.org> c6c5c1b
- release 3

* Sat Dec 22 2018 Jakub Bogusz <qboosh@pld-linux.org> 029e8be
- bootstrap release 2.1

* Sun Sep 02 2018 Jakub Bogusz <qboosh@pld-linux.org> bc09322
- release 2 (rebuild with harfbuzz support)

* Thu Aug 02 2018 Jakub Bogusz <qboosh@pld-linux.org> 8aad7d7
- release 1.1 (bootstrap rebuild without harfbuzz)

* Wed May 16 2018 Jakub Bogusz <qboosh@pld-linux.org> fc8c502
- updated to 2.9.1

* Fri Mar 09 2018 Jakub Bogusz <qboosh@pld-linux.org> f061912
- updated to 2.9

* Tue Nov 14 2017 Jakub Bogusz <qboosh@pld-linux.org> 0ec88fb
- updated to 2.8.1

* Sun May 14 2017 Jakub Bogusz <qboosh@pld-linux.org> f206c06
- updated to 2.8 (fixes CVE-2017-8105 CVE-2017-8287)

* Sun Jan 22 2017 Jakub Bogusz <qboosh@pld-linux.org> 2a902e2
- updated to 2.7.1

* Wed Dec 28 2016 Jakub Bogusz <qboosh@pld-linux.org> 82c6084
- release 2

